devplugin

## Interface PluginAccess

- All Superinterfaces:
    ButtonActionIf, java.lang.Comparable<ProgramReceiveIf>, ContextMenuIf, Marker, ProgramReceiveIf
  All Known Subinterfaces:
    PluginProxy
  All Known Implementing Classes:
    AbstractPluginProxy, BeanShellPluginProxy, JavaPluginProxy

      public interface PluginAccess
      extends ButtonActionIf, Marker, ProgramReceiveIf, ContextMenuIf

  An access to another plugin.

  Contains all operations that may be called on a plugin from another plugin.

  Author:
    Til Schneider, www.murfman.de

- - ### Field Summary

    - ### Fields inherited from interface devplugin.ContextMenuIf

      `ACTIONKEY_KEYBOARD_EVENT`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PluginsProgramFilter[]` | `getAvailableFilter()` Returns the available program filters that the plugin supports.
    `java.lang.Class<? extends PluginsFilterComponent>[]` | `getAvailableFilterComponentClasses()` Returns the available plugins filter component classes.
    `PluginCommunication` | `getCommunicationClass()` If this Plugin grants access to functions it will provide a communication class for other Plugins to use.
    `java.lang.String` | `getId()` Gets the ID of this plugin.
    `PluginInfo` | `getInfo()` Gets the meta information about the plugin.
    `javax.swing.Icon` | `getMarkIcon()` Gets the icon to use for marking programs in the program table.
    `javax.swing.Icon[]` | `getMarkIcons(Program p)` Gets the icons to use for marking programs in the program table.
    `ProgramRatingIf[]` | `getProgramRatingIfs()` If this plugin can rate programs, this interface makes it possible to offer this ratings to other plugins.
    `javax.swing.Icon[]` | `getProgramTableIcons(Program program)` Gets the icons this Plugin provides for the given program.
    `java.lang.String` | `getProgramTableIconText()` Gets the description text for the program table icons provided by this Plugin.
    `ToolTipIcon[]` | `getProgramTableToolTipIcons(Program program)` Gets the ToolTipIcons for the program table icons provided by this Plugin.

    - ### Methods inherited from interface tvbrowser.core.plugin.ButtonActionIf

      `getButtonAction, getButtonActionDescription`

    - ### Methods inherited from interface devplugin.Marker

      `getMarkPriorityForProgram`

    - ### Methods inherited from interface devplugin.ProgramReceiveIf

      `canReceiveProgramsWithTarget, getProgramReceiveTargets, receivePrograms, receiveValues`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

    - ### Methods inherited from interface devplugin.ContextMenuIf

      `getContextMenuActions`

- - ### Method Detail

    - #### getId

          java.lang.String getId()

      Gets the ID of this plugin.
      Specified by:
        `getId` in interface `ButtonActionIf`
      Specified by:
        `getId` in interface `ContextMenuIf`
      Specified by:
        `getId` in interface `Marker`
      Specified by:
        `getId` in interface `ProgramReceiveIf`
      Returns:
        The ID of this plugin.

    - #### getInfo

          PluginInfo getInfo()

      Gets the meta information about the plugin.
      Returns:
        The meta information about the plugin.

    - #### getProgramTableIconText

          java.lang.String getProgramTableIconText()

      Gets the description text for the program table icons provided by this Plugin.

      Return `null` if your plugin does not provide this feature.

      Returns:
        The description text for the program table icons or `null` if the plugin does not provide this feature.
      See Also:
        `getProgramTableIcons(Program)`

    - #### getProgramTableToolTipIcons

          ToolTipIcon[] getProgramTableToolTipIcons(Program program)

      Gets the ToolTipIcons for the program table icons provided by this Plugin.

      Override this method if your plugin provides icons for the program table (shown below the start time) and you want the icons to be shown in the tooltip.

      Parameters:
        `program` - The program to get the ToolTipIcons for.
      Returns:
        The description text for the program table icons or `null` if the plugin does not provide this feature.
      Since:
        3.4.2
      See Also:
        `getProgramTableIcons(Program)`

    - #### getProgramTableIcons

          javax.swing.Icon[] getProgramTableIcons(Program program)

      Gets the icons this Plugin provides for the given program. These icons will be shown in the program table under the start time.

      Return `null` if your plugin does not provide this feature.

      Parameters:
        `program` - The programs to get the icons for.
      Returns:
        The icons for the given program or `null`.
      See Also:
        `getProgramTableIconText()`

    - #### getMarkIcon

          javax.swing.Icon getMarkIcon()

      Gets the icon to use for marking programs in the program table. Should be 16x16.
      Specified by:
        `getMarkIcon` in interface `Marker`
      Returns:
        the icon to use for marking programs in the program table.

    - #### getMarkIcons

          javax.swing.Icon[] getMarkIcons(Program p)

      Gets the icons to use for marking programs in the program table. Should be 16x16.
      Specified by:
        `getMarkIcons` in interface `Marker`
      Returns:
        the icons to use for marking programs in the program table.
      Since:
        2.5

    - #### getAvailableFilter

          PluginsProgramFilter[] getAvailableFilter()

      Returns the available program filters that the plugin supports.
      Returns:
        The available program filters that the plugin supports or `null` if it supports no filter.
      Since:
        2.5

    - #### getAvailableFilterComponentClasses

          java.lang.Class<? extends PluginsFilterComponent>[] getAvailableFilterComponentClasses()

      Returns the available plugins filter component classes.
      ATTENTON: Use return `(Class[]) new Class[] {MyFilterComponent1.class,MyFilterComponent2.class};` because the creation of a class array with generic type didn't work.
      Returns:
        The available plugins filter components classes or `null` if no plugins filter components are supported.
      Since:
        2.5

    - #### getProgramRatingIfs

          ProgramRatingIf[] getProgramRatingIfs()

      If this plugin can rate programs, this interface makes it possible to offer this ratings to other plugins. You can get all ProgramRatingIfs of all plugins using `PluginManager.getAllProgramRatingIfs()` The plugin can return more than one ratingif, e.g. average ratings, user rating ...
      Returns:
        the RatingIfs of this plugin
      Since:
        2.7

    - #### getCommunicationClass

          PluginCommunication getCommunicationClass()

      If this Plugin grants access to functions it will provide a communication class for other Plugins to use.

      Returns:
        The communication class of this Plugin or `null` if there is no communication class for this Plugin.
      Since:
        3.3.4

TV-Browser 3.4.3, Copyright (C) 2004-2008 TV-Browser Team (dev@tvbrowser.org)